#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lanhep.h"

#undef DBG_PPL

static int prop_gened = 0;

static Atom PROP_PPL=0;
static List vlist = 0;
static List plist = 0;
static List dlist=0;
static List out_prt=0, excl_prt = 0, incl_prt = 0, tadpoles=1;
static int set_ppl(void), proc_param(Term);
static Atom psfile=0;

static int p__cmp(Term p1, Term p2)
	{
	return strcmp(AtomValue(p1),AtomValue(p2));
	}

static Atom remcc(Atom a)
{
	Term prop=GetAtomProperty(a,PROP_TYPE);
	if(is_compound(prop) && CompoundName(prop)==OPR_FIELD &&
					CompoundArg2(prop)==NewInteger(4))
				return CompoundArg1(prop);
	return a;
}

static void insprt(Term, int), drawdiag(void);

Term ProcGenDiagr(Term t, Term ind)
	{
	static List tl=0;
	List l;
	if(PROP_PPL==0) PROP_PPL=NewAtom("pprtlst",0);
	psfile=0;
	
	if(tl==0)
	{
		Term t=MakeCompound(A_I,5);
		SetCompoundArg(t,1,NewInteger(1));
		SetCompoundArg(t,2,MakeList1(MakeList4(
				NewInteger(-1),NewInteger(-2),NewInteger(1),NewInteger(1))));
		SetCompoundArg(t,3,MakeList2(0,0));
		SetCompoundArg(t,4,MakeList1(0));
		tl=AppendLast(tl,t);
		t=MakeCompound(A_I,5);
		SetCompoundArg(t,1,NewInteger(2));
		SetCompoundArg(t,2,MakeList2(
				MakeList3(NewInteger(-1),NewInteger(2),NewInteger(2)),
				MakeList3(NewInteger(-2),NewInteger(1),NewInteger(1))));
		SetCompoundArg(t,3,MakeList2(0,0));
		SetCompoundArg(t,4,MakeList2(0,0));
		tl=AppendLast(tl,t);
		if(tadpoles)
		{
			Term t=MakeCompound(A_I,5);
			SetCompoundArg(t,1,NewInteger(3));
			SetCompoundArg(t,2,MakeList2(
					MakeList3(NewInteger(-1),NewInteger(-2),NewInteger(2)),
					MakeList3(NewInteger(1),NewInteger(2),NewInteger(2))));
			SetCompoundArg(t,3,MakeList2(0,0));
			SetCompoundArg(t,4,MakeList2(0,0));
			tl=AppendLast(tl,t);
		}
		/*DumpList(tl);*/
	}
	
	if(set_ppl()==0)
		return 0;
	
	if(!proc_param(t))
		return 0;
	
	if(ListLength(out_prt)!=2)
	{
		puts("prtno unsupported!");
		return 0;
	}
	
	for(l=tl;l;l=ListTail(l))
	{
		Term t=CopyTerm(ListFirst(l));
		List l1,l2;
		SetCompoundArg(t,3,CopyTerm(out_prt));
		for(l1=CompoundArg2(t);l1;l1=ListTail(l1))
		for(l2=ListFirst(l1);l2;l2=ListTail(l2))
			if(is_integer(ListFirst(l2)) && IntegerValue(ListFirst(l2))<0)
				ChangeList(l2,
					MakeCompound1(ListNth(out_prt,-IntegerValue(ListFirst(l2))),
							ListFirst(l2)));
		/*WriteTerm(t);puts("");*/
		insprt(t,1);
		FreeAtomic(t);
	}
	
	DumpList(dlist);
	puts("gendiagr finished");
	
	if(psfile)
		drawdiag();
	
	return 0;		
	
	}
	
static int set_ppl(void)
	{
	List l;
	if(prop_gened)
		return 1;
	if(vlist==0) 
		
	{
		vlist=all_vert_list();
		for(l=vlist; !is_empty_list(l); l=ListTail(l))
		{
		Term a2;
		a2=ListFirst(l); 
		alg2_common_s(a2);
		alg2_common_n(a2);
		alg2_red_cos(a2);
		alg2_red_orth(a2);
		}
	}
			
	for(l=vlist; !is_empty_list(l); l=ListTail(l))
		{
		List pl,l1,l2,lr;
		
		pl=CompoundArg1(ListFirst(l));
		if(ListLength(pl)<3 || CompoundArg2(ListFirst(l))==NewInteger(0) ||
		 is_empty_list(CompoundArgN(ListFirst(l),5)))
			continue;
			

#ifdef DBG_PPL
		WriteVertex(pl); printf(": ");
#endif
		
		l1=pl;
		while(!is_empty_list(l1))
			{
			Atom pp,app;
			Term prop;
			pp=CompoundArg1(ListFirst(l1));
			prop=GetAtomProperty(pp,PROP_TYPE);
			app=remcc(pp);
			if(!ListMember(plist,app))
				plist=AppendFirst(plist,app);
			
#ifdef DBG_PPL
			WriteTerm(app); printf(" -> ");
#endif
			
			
			lr=NewList();
			l2=pl;
			while(!is_empty_list(l2))
				{
				Atom a;
				if(l2==l1)
					{
					l2=ListTail(l2);
					continue;
					}
				a=remcc(CompoundArg1(ListFirst(l2)));
				lr=AppendLast(lr,a);
				l2=ListTail(l2);
				}
			
			prop=GetAtomProperty(app,PROP_PPL);
			if(prop==0)
				SetAtomProperty(app,PROP_PPL,AppendFirst(NewList(),lr));
			else
				AppendLast(prop,lr);
#ifdef DBG_PPL
			WriteTerm(lr); printf(" ");
#endif
			while(!is_empty_list(l1) && 
					remcc(CompoundArg1(ListFirst(l1)))==app)
				l1=ListTail(l1);
			}
#ifdef DBG_PPL
		puts("");
#endif
		}
		
	if(ListLength(plist)>1)		
		plist=SortedList(plist,p__cmp);
		
	prop_gened=1;
	return 1;
	}


static int proc_param(Term t)
	{
	int i;
	
	if(!is_compound(t))
		return 0;
	for(i=1;i<=CompoundArity(t);i++)
		{
		Term t1;
		t1=ConsumeCompoundArg(t,i);

		if( is_list(t1) )
			{
			List l;
			for(l=t1;l;l=ListTail(l))
			{
				if(!ListMember(plist,ListFirst(l)))
				{
					printf("GenDiagr: indefined particle ");
					WriteTerm(ListFirst(l));
					puts("");
					return 0;
				}
			}
			out_prt=t1;
			continue;
			}
		
		if(is_compound(t1) && CompoundName(t1)==OPR_EQSIGN && 
			CompoundArity(t1)==2 && is_atom(CompoundArg1(t1)) &&
			is_list(CompoundArg2(t1)) && 
			strcmp(AtomValue(CompoundArg1(t1)),"exclude")==0)
			{
			List l;
			excl_prt=ConsumeCompoundArg(t1,2);
			for(l=excl_prt;!is_empty_list(l);l=ListTail(l))
				{
				if(!is_particle(ListFirst(l),NULL))
					{
					printf("Error: GenDiagr: '");
					WriteTerm(ListFirst(l));
					puts("' is not a particle");
					return 0;
					}
				}
			continue;
			}
		if(is_compound(t1) && CompoundName(t1)==OPR_EQSIGN && 
			CompoundArity(t1)==2 && is_atom(CompoundArg1(t1)) &&
			is_atom(CompoundArg2(t1)) && 
			strcmp(AtomValue(CompoundArg1(t1)),"psfile")==0)
			{
			psfile=CompoundArg2(t1);
			continue;
			}
		if(is_compound(t1) && CompoundName(t1)==OPR_EQSIGN && 
			CompoundArity(t1)==2 && is_atom(CompoundArg1(t1)) &&
			is_list(CompoundArg2(t1)) && 
			strcmp(AtomValue(CompoundArg1(t1)),"include")==0)
			{
			List l;
			incl_prt=ConsumeCompoundArg(t1,2);
			for(l=incl_prt;!is_empty_list(l);l=ListTail(l))
				{
				if(!is_particle(ListFirst(l),NULL))
					{
					printf("Error: GenDiagr: '");
					WriteTerm(ListFirst(l));
					puts("' is not a particle");
					return 0;
					}
				}
			continue;
			}
		printf("Error: Unknown keyword '");WriteTerm(t1);printf("' in GenDiagr\n");
		FreeAtomic(t1);
		}
		
	FreeAtomic(t);
	
	return 1;
	}

static Atom anti(Atom p)
{
	Atom a=GetAtomProperty(p,A_ANTI2);
	if(a) return a;
	return GetAtomProperty(p,A_ANTI);
}
	
static void insprt(Term t, int lv)
{
	List wl=ListNthList(CompoundArg2(t),lv);
	Atom prt1;
	List l1,l2,sl;
	
	if(wl==0)
	{
		l2=0;
		for(l1=CompoundArgN(t,4);l1;l1=ListTail(l1))
		{
			Term prp=GetAtomProperty(ListFirst(l1),PROP_TYPE);
			if(is_compound(prp)&&CompoundName(prp)==OPR_FIELD)
				prp=GetAtomProperty(CompoundArg1(prp),PROP_TYPE);
			if(!is_compound(prp)||CompoundName(prp)!=OPR_PARTICLE)
				puts("Internal error (gdifmlu)");
			l2=AppendLast(l2,CompoundArgN(prp,5));
		}
		SetCompoundArg(t,5,l2);
		dlist=AppendLast(dlist,CopyTerm(t));
		return;
	}
	
	wl=ListNth(CompoundArg2(t),lv);
	prt1=CompoundName(ListFirst(wl));
	
	sl=GetAtomProperty(prt1,PROP_PPL);
	for(l1=sl;l1;l1=ListTail(l1))
	{
		List lc;
		Term ct;
		List cwl;
		if(ListLength(ListFirst(l1))!=ListLength(wl)-1)
			continue;
		lc=CopyTerm(ListFirst(l1));
		for(l2=ListTail(wl);l2;l2=ListTail(l2))
		{
			if(is_compound(ListFirst(l2)))
			{
				Atom a=CompoundName(ListFirst(l2));
				int p=ListMember(lc,a);
				if(p==0) break;
				else
					lc=CutFromList(lc,ListNthList(lc,p));
			}
			else break;
		}
		if(l2 && is_compound(ListFirst(l2)))
		{
			if(lc) FreeAtomic(lc);
			continue;
		}
		if(lc==0)
		{
			insprt(t,lv+1);
			return;
		}
		/*WriteTerm(lc);WriteTerm(l2);puts("");*/
		ct=CopyTerm(t);
		cwl=ListNth(CompoundArg2(ct),lv);
		for(l2=cwl;l2&&is_compound(ListFirst(l2));l2=ListTail(l2));
		switch(ListLength(lc))
		{
		case 1:
			{
				int d=IntegerValue(ListFirst(l2));
				ChangeList(l2,MakeCompound1(ListFirst(lc),NewInteger(d)));
				cwl=ListNth(CompoundArg2(ct),d);
				for(l2=cwl;l2;l2=ListTail(l2))
					if(is_integer(ListFirst(l2))&&
							IntegerValue(ListFirst(l2))==lv)
						break;
				if(l2==0){puts("Internal errol (gdmcp)");return;}
				ChangeList(l2,MakeCompound1(
						anti(ListFirst(lc)),NewInteger(lv)));
				for(l2=CompoundArgN(ct,4);l2&&ListFirst(l2);l2=ListTail(l2));
				ChangeList(l2,ListFirst(lc));
				insprt(ct,lv+1);
				break;
			}
		case 2:
			{
				int d1=IntegerValue(ListFirst(l2));
				int d2=IntegerValue(ListFirst(ListTail(l2)));
				if(d1==d2 && d1==lv)
				{
					if(ListFirst(lc)!=anti(ListFirst(ListTail(lc))))
							break;
					ChangeList(l2,MakeCompound1(ListFirst(lc),NewInteger(lv)));
					ChangeList(ListTail(l2),
							MakeCompound1(ListFirst(ListTail(lc)),NewInteger(lv)));
					for(l2=CompoundArgN(ct,4);l2&&ListFirst(l2);l2=ListTail(l2));
					ChangeList(l2,ListFirst(lc));
					insprt(ct,lv+1);
					break;
				}
				
				{
					ChangeList(l2,MakeCompound1(ListFirst(lc),NewInteger(d1)));
					ChangeList(ListTail(l2),
							MakeCompound1(ListFirst(ListTail(lc)),NewInteger(d2)));
					cwl=ListNth(CompoundArg2(ct),d1);
					for(l2=cwl;l2;l2=ListTail(l2))
						if(is_integer(ListFirst(l2))&&
								IntegerValue(ListFirst(l2))==lv)
							break;
					if(l2==0){puts("Internal errol (gdmcp2)");return;}
					ChangeList(l2,MakeCompound1(
							anti(ListFirst(lc)),NewInteger(lv)));
					cwl=ListNth(CompoundArg2(ct),d2);
					for(l2=cwl;l2;l2=ListTail(l2))
						if(is_integer(ListFirst(l2))&&
								IntegerValue(ListFirst(l2))==lv)
							break;
					if(l2==0){puts("Internal errol (gdmcp2a)");return;}
					ChangeList(l2,MakeCompound1(
							anti(ListFirst(ListTail(lc))),NewInteger(lv)));
					for(l2=CompoundArgN(ct,4);l2&&ListFirst(l2);l2=ListTail(l2));
					ChangeList(l2,ListFirst(lc));
					ChangeList(ListTail(l2),ListFirst(ListTail(lc)));
					insprt(ct,lv+1);
				}
				if(d1==d2 || ListFirst(lc)==ListFirst(ListTail(lc)))
					break;
				{
					FreeAtomic(ct);FreeAtomic(lc);
					ct=CopyTerm(t);
					cwl=ListNth(CompoundArg2(ct),lv);
					for(l2=cwl;l2&&is_compound(ListFirst(l2));l2=ListTail(l2));
					
					ChangeList(l2,MakeCompound1(ListFirst(ListTail(lc)),NewInteger(d1)));
					ChangeList(ListTail(l2),MakeCompound1(ListFirst(lc),NewInteger(d2)));
					cwl=ListNth(CompoundArg2(ct),d1);
					for(l2=cwl;l2;l2=ListTail(l2))
						if(is_integer(ListFirst(l2))&&
								IntegerValue(ListFirst(l2))==lv)
							break;
					if(l2==0){puts("Internal errol (gdmcp2b)");return;}
					ChangeList(l2,MakeCompound1(
							anti(ListFirst(ListTail(lc))),NewInteger(lv)));
					cwl=ListNth(CompoundArg2(ct),d2);
					for(l2=cwl;l2;l2=ListTail(l2))
						if(is_integer(ListFirst(l2))&&
								IntegerValue(ListFirst(l2))==lv)
							break;
					if(l2==0){puts("Internal errol (gdmcp2c)");return;}
					ChangeList(l2,MakeCompound1(
							anti(ListFirst(lc)),NewInteger(lv)));
					for(l2=CompoundArgN(ct,4);l2&&ListFirst(l2);l2=ListTail(l2));
					ChangeList(l2,ListFirst(ListTail(lc)));
					ChangeList(ListTail(l2),ListFirst(lc));
					insprt(ct,lv+1);
				}
				break;
			}
		default:
				printf("Unsupported case in insprt: %d\n",ListLength(lc));
		}
					
		FreeAtomic(ct);FreeAtomic(lc);
		
	}
	
}

static int isanti(Atom p)
{
	Term prp=GetAtomProperty(p,PROP_TYPE);
	
	if(!is_compound(prp))
	{
		puts("Internal error gendisaf.");
		return 0;
	}
	if(CompoundName(prp)==OPR_FIELD)
	{
		if(CompoundArg2(prp)==NewInteger(2))
			return 1;
		if(CompoundArg2(prp)==NewInteger(3))
			return -1;
		p=CompoundArg1(prp);
		prp=GetAtomProperty(p,PROP_TYPE);
	}
	if(CompoundArg1(prp)==CompoundArg2(prp))
		return 0;
	if(CompoundArg1(prp)==p)
		return 1;
	return -1;
}

static int W=770, H=750;

void drawdiag(void)
{
	int c; 
	List l;
	char cbuf[32];
	psOpen(AtomValue(psfile),0,1);
	
	for(l=dlist,c=0;l;l=ListTail(l),c++)
	{
		int x=c%3, y=(c/3)%4,i=0;
		List oprt=CompoundArgN(ListFirst(l),3),
			 iprt=CompoundArgN(ListFirst(l),4),l2;
		Atom pa[10];
		int ori[10];
		
		for(l2=oprt;l2;l2=ListTail(l2),i++) pa[i]=ListFirst(l2);
		for(l2=iprt;l2;l2=ListTail(l2),i++) pa[i]=ListFirst(l2);
		pa[i]=0;
		for(i=0;pa[i];i++)
		{
			ori[i]=isanti(pa[i]);
			if(ori[i]==-1) pa[i]=anti(pa[i]);
		}
		x*=W;y*=H;x+=60;y+=140;
		psRect(x+20,y+20,W-40,H-40,2,0);
		sprintf(cbuf,"Diagram %d",c+1);
		psOutText(x+W/2-120,y+H-80,cbuf,0,4);
		switch(IntegerValue(CompoundArg1(ListFirst(l))))
		{
			case 1:
				if(ori[0]==1)
				{
					psLine(x+120+W/10,y+H/2+H/8,x+120+W/10+30,y+H/2+H/8+10,4);
					psLine(x+120+W/10,y+H/2+H/8,x+120+W/10+30,y+H/2+H/8-10,4);
				}
				if(ori[0]==-1)
				{
					psLine(x+150+W/10,y+H/2+H/8,x+150+W/10-30,y+H/2+H/8+10,4);
					psLine(x+150+W/10,y+H/2+H/8,x+150+W/10-30,y+H/2+H/8-10,4);
				}
				psOutText(x+150,y+H/2+H/8-30,AtomValue(pa[0]),0,4);
				if(ori[1]==1)
				{
					psLine(x+W-120-W/10,y+H/2+H/8,x+W-120-W/10-30,y+H/2+H/8+10,4);
					psLine(x+W-120-W/10,y+H/2+H/8,x+W-120-W/10-30,y+H/2+H/8-10,4);
				}
				if(ori[1]==-1)
				{
					psLine(x+W-150-W/10,y+H/2+H/8,x+W-150-W/10+30,y+H/2+H/8+10,4);
					psLine(x+W-150-W/10,y+H/2+H/8,x+W-150-W/10+30,y+H/2+H/8-10,4);
				}
				psOutText(x-150+W-psTextWidth(AtomValue(pa[1]),0,4),y+H/2+H/8-30,
						AtomValue(pa[1]),0,4);
				if(ori[2])
				{
					psLine(x+W/2-15,y+H/2-H/8,x+W/2+15,y+H/2-H/8+10,4);
					psLine(x+W/2-15,y+H/2-H/8,x+W/2+15,y+H/2-H/8-10,4);
				}
				psOutText(x+W/2-psTextWidth(AtomValue(pa[2]),0,4)/2,y+H/2-H/8-30,
						AtomValue(pa[2]),0,4);
				psLine(x+120,y+H/2+H/8,x+W-120,y+H/2+H/8,4);
				psRing(x+W/2,y+H/2,H/8-2,H/8+1,0);
				psRing(x+W/2,y+H/2+H/8,1,10,0);
					
				break;
			case 2:
				if(ori[0]==1)
				{
					psLine(x+120+W/10,y+H/2,x+120+W/10+30,y+H/2+10,4);
					psLine(x+120+W/10,y+H/2,x+120+W/10+30,y+H/2-10,4);
				}
				if(ori[0]==-1)
				{
					psLine(x+150+W/10,y+H/2,x+150+W/10-30,y+H/2+10,4);
					psLine(x+150+W/10,y+H/2,x+150+W/10-30,y+H/2-10,4);
				}
				psOutText(x+150,y+H/2-30,AtomValue(pa[0]),0,4);
				if(ori[1]==1)
				{
					psLine(x+W-120-W/10,y+H/2,x+W-120-W/10-30,y+H/2+10,4);
					psLine(x+W-120-W/10,y+H/2,x+W-120-W/10-30,y+H/2-10,4);
				}
				if(ori[1]==-1)
				{
					psLine(x+W-150-W/10,y+H/2,x+W-150-W/10+30,y+H/2+10,4);
					psLine(x+W-150-W/10,y+H/2,x+W-150-W/10+30,y+H/2-10,4);
				}
				psOutText(x-150+W-psTextWidth(AtomValue(pa[1]),0,4),y+H/2-30,
						AtomValue(pa[1]),0,4);
				if(ori[2]==-1)
				{
					psLine(x+W/2-15,y+H/2-H/8,x+W/2+15,y+H/2-H/8+10,4);
					psLine(x+W/2-15,y+H/2-H/8,x+W/2+15,y+H/2-H/8-10,4);
				}
				if(ori[2]==1)
				{
					psLine(x+W/2+15,y+H/2-H/8,x+W/2-15,y+H/2-H/8+10,4);
					psLine(x+W/2+15,y+H/2-H/8,x+W/2-15,y+H/2-H/8-10,4);
				}
				psOutText(x+W/2-psTextWidth(AtomValue(pa[2]),0,4)/2,y+H/2-H/8-30,
						AtomValue(pa[2]),0,4);
				if(ori[3]==-1)
				{
					psLine(x+W/2-15,y+H/2+H/8,x+W/2+15,y+H/2+H/8+10,4);
					psLine(x+W/2-15,y+H/2+H/8,x+W/2+15,y+H/2+H/8-10,4);
				}
				if(ori[3]==1)
				{
					psLine(x+W/2+15,y+H/2+H/8,x+W/2-15,y+H/2+H/8+10,4);
					psLine(x+W/2+15,y+H/2+H/8,x+W/2-15,y+H/2+H/8-10,4);
				}
				psOutText(x+W/2-psTextWidth(AtomValue(pa[3]),0,4)/2,y+H/2+H/8-30,
						AtomValue(pa[3]),0,4);
				psLine(x+120,y+H/2,x+W/2-H/8,y+H/2,4);
				psLine(x+W/2+H/8,y+H/2,x+W-120,y+H/2,4);
				psRing(x+W/2,y+H/2,H/8-2,H/8+1,0);
				psRing(x+W/2-H/8,y+H/2,1,10,0);
				psRing(x+W/2+H/8,y+H/2,1,10,0);
				break;
			case 3:
				if(ori[0]==1)
				{
					psLine(x+120+W/10,y+H/2+H/6,x+120+W/10+30,y+H/2+H/6+10,4);
					psLine(x+120+W/10,y+H/2+H/6,x+120+W/10+30,y+H/2+H/6-10,4);
				}
				if(ori[0]==-1)
				{
					psLine(x+150+W/10,y+H/2+H/6,x+150+W/10-30,y+H/2+H/6+10,4);
					psLine(x+150+W/10,y+H/2+H/6,x+150+W/10-30,y+H/2+H/6-10,4);
				}
				psOutText(x+150,y+H/2+H/6-30,AtomValue(pa[0]),0,4);
				if(ori[1]==1)
				{
					psLine(x+W-120-W/10,y+H/2+H/6,x+W-120-W/10-30,y+H/2+H/6+10,4);
					psLine(x+W-120-W/10,y+H/2+H/6,x+W-120-W/10-30,y+H/2+H/6-10,4);
				}
				if(ori[1]==-1)
				{
					psLine(x+W-150-W/10,y+H/2+H/6,x+W-150-W/10+30,y+H/2+H/6+10,4);
					psLine(x+W-150-W/10,y+H/2+H/6,x+W-150-W/10+30,y+H/2+H/6-10,4);
				}
				psOutText(x-150+W-psTextWidth(AtomValue(pa[1]),0,4),y+H/2+H/6-30,
						AtomValue(pa[1]),0,4);
				psOutText(x+W/2-psTextWidth(AtomValue(pa[2]),0,4)-30,y+H/2+H/7-30,
						AtomValue(pa[2]),0,4);
				if(ori[3])
				{
					psLine(x+W/2-15,y+H/2-H/4,x+W/2+15,y+H/2-H/4+10,4);
					psLine(x+W/2-15,y+H/2-H/4,x+W/2+15,y+H/2-H/4-10,4);
				}
				psOutText(x+W/2-psTextWidth(AtomValue(pa[3]),0,4)/2,y+H/2-H/4-30,
						AtomValue(pa[3]),0,4);
				psLine(x+120,y+H/2+H/6,x+W-120,y+H/2+H/6,4);
				psLine(x+W/2,y+H/2+H/6,x+W/2,y+H/2,4);
				psRing(x+W/2,y+H/2-H/8,H/8-2,H/8+1,0);
				psRing(x+W/2,y+H/2,1,10,0);
				psRing(x+W/2,y+H/2+H/6,1,10,0);
				break;
			default:
					printf("Unknown topology %d\n",
					IntegerValue(CompoundArg1(ListFirst(l))));
		}
		if((c+1)%12==0)
			psNextPage(0);
	}
	
	psClose();
	
}


