<< ../FeynArts/FeynArts.m '
<< FormCalcMy.m '

process = {prt["H3"],prt["H3"]} -> {prt["l"],prt["L"]}

SetOptions[InsertFields,Model->model9, GenericModel->model9,
	   ExcludeParticles->{ (*F[1],F[2],F[3],F[4],F[5],F[6],F[7],F[8],
	   		F[9],F[10],F[11],F[12],S[7],S[8],S[9],
				S[10],S[11],S[12],S[13],S[14],S[15],
				S[16],S[17],S[18],S[19],S[20],S[21],
				S[22],S[23],S[24],S[25],S[26],S[27]
		    F[13],F[14],F[15],F[16],F[17],F[18],
		      S[1],S[2],S[3],S[4],S[5],S[6],  S[7],S[8],S[9],
				S[10],S[11],S[12],S[13],S[14],S[15],
				S[16],S[17],S[18],S[19],S[20],S[21],
				S[22],S[23],S[24],S[25],S[26],S[27]*) }]


CKM = IndexDelta

(*Small[ME]=0*)

DoPaint[diags_, file_] := (
  If[ FileType["diagrams"] =!= Directory,
    CreateDirectory["diagrams"] ];
  Paint[diags, 
    DisplayFunction -> (Display["diagrams/" <> file <> ".ps", #]&)]
)

     (*Hel[_] = 0*)

Print["Born"]

tops = CreateTopologies[0, 2 -> 2];
ins = InsertFields[ tops, process ];
DoPaint[ins, "born"];
born = CalcFeynAmp[CreateFeynAmp[ins]]


Print["Counter terms"]

tops = CreateCTTopologies[1, 2 -> 2,
  ExcludeTopologies -> {TadpoleCTs, WFCorrectionCTs}];
ins = InsertFields[tops, process];
DoPaint[ins, "counter"];
counter = CreateFeynAmp[ins];


Print["Self energies"]

tops = CreateTopologies[1, 2 -> 2, SelfEnergiesOnly];
ins = InsertFields[tops, process];
DoPaint[ins, "self"];
self = CalcFeynAmp[
  CreateFeynAmp[ins],
  Select[counter, DiagramType[#] == 2 &]];


Print["Vertices"]

tops = CreateTopologies[1, 2 -> 2, TrianglesOnly];
ins = InsertFields[tops, process];
DoPaint[ins, "vert"];
vert = CalcFeynAmp[
  CreateFeynAmp[ins],
  Select[counter, DiagramType[#] == 1 &]];


Print["Boxes"]

tops = CreateTopologies[1, 2 -> 2, BoxesOnly];
ins = InsertFields[tops, process ];
DoPaint[ins, "box"];
box = CalcFeynAmp[
  CreateFeynAmp[ins],
  Select[counter, DiagramType[#] == 0 &]];

abbr = OptimizeAbbr[Abbr[]]


hel = HelicityME[All, born]

col = ColourME[All, born]


(*sme=SquaredME[born,born]*)

WriteSquaredME[born, {self, vert, box}, hel, col, Abbr[], "fortran_susy"]

$PaintSE = "rc";

InsertFieldsHook[tops_, f1_ -> f2_] :=
  InsertFields[tops, f1 -> f2  (*,
  	ExcludeParticles->{}*) ];

WriteRenConst[{self, vert, box}, "fortran_susy"]


Print["time used: ", SessionTime[] - time1]

