      PROGRAM CPsuperH
************************************************************************
*
************************************************************************
      IMPLICIT REAL*8(A-H,M,O-Z)
*
*-----------------------------------------------------------------------
*ARRAYS:
      REAL*8 SMPARA_H(15),SSPARA_H(21)
      DATA NSMIN/15/
      DATA NSSIN/21/
*
      INTEGER*8 IFLAG_H(100)
      DATA NFLAG/100/
*
      REAL*8     HMASS_H(3),OMIX_H(3,3)
      REAL*8     STMASS_H(2),SBMASS_H(2),STAUMASS_H(2),SNU3MASS_H
      REAL*8     MC_H(2),MN_H(4)
      COMPLEX*16 STMIX_H(2,2),SBMIX_H(2,2),STAUMIX_H(2,2)
      COMPLEX*16 UL_H(2,2),UR_H(2,2),N_H(4,4)
*
* Higgs potential couplings
      REAL*8     LR_H(4)
      COMPLEX*16 LC_H(3)
      COMPLEX*16 HB_H,HT_H, CKB_H, CKT_H
	  
      COMPLEX*16 NHC_H(100,3)  ! 100 = NCMAX
      REAL*8     SHC_H(100)
      COMPLEX*16 CHC_H(100)
      DATA NCMAX/100/
*
      REAL*8 GAMBRN(101,3,3)   ! 101 = IFLAG_H(20)+IFLAG_H(21)+1 = NMNH
*                                      ISMN       =ISUSYN        = 50
      REAL*8 GAMBRC(51,3)      !  51 = IFLAG_H(22)+IFLAG_H(23)+1 = NMCH
*                                      ISMC       =ISUSYC        = 25
      DATA NMNH/101/
      DATA NMCH/51/
*-----------------------------------------------------------------------
      open(21, FILE='micromegas.in',STATUS='UNKNOWN')

*read in input data from the file 'run'
*
      DO IP=1,NSMIN
       READ(*,*) SMPARA_H(IP)
      ENDDO
      DO IP=1,NSSIN
       READ(*,*) SSPARA_H(IP)
      ENDDO
*-----------------------------------------------------------------------
*initialize 
*
      DO IFLAG=1,NFLAG
       IFLAG_H(IFLAG)=0
      ENDDO
*
      DO INC=1,NCMAX
        DO IH=1,3
         NHC_H(INC,IH)=DCMPLX(0.D0,0.D0)
        ENDDO
         CHC_H(INC)=DCMPLX(0.D0,0.D0)
         SHC_H(INC)=0.D0
      ENDDO
*
      DO IM=1,NMNH
        DO IWB=1,3
          DO IH=1,3
            GAMBRN(IM,IWB,IH)=0.D0
          ENDDO
        ENDDO
      ENDDO
      DO IM=1,NMCH
        DO IWB=1,3
          GAMBRC(IM,IWB)=0.D0
        ENDDO
      ENDDO
*-----------------------------------------------------------------------
*Set some flag's
*
      READ(*,*) IFLAG_H( 1) ! '1' will print input parameters
      READ(*,*) IFLAG_H( 2) ! '1' will print Higgs sector
      READ(*,*) IFLAG_H( 3) ! '1' will print masses and mixings of 
*                             stop and sbottom sectors
      READ(*,*) IFLAG_H( 4) ! '1' will print masses and mixings of chargino and 
*                             neutralino sectors
      READ(*,*) IFLAG_H( 5) ! '1-6' will print Higgs boson couplings
      READ(*,*) IFLAG_H( 6) ! '1-5' will print Higgs boson decays 
      READ(*,*) IFLAG_H(10) ! if 0, include radiative corrections to 
*                             H-top-top and H-bot-bot Yukawa couplings
      READ(*,*) IFLAG_H(11) ! if 0, use pole Higgs masses
*                             if 1, use effective potential Higgs mass
*
      IFLAG_H(11)=1
      IFLAG_H(20) = (NMNH-1)/2      ! ISMN
      IFLAG_H(21) = (NMNH-1)/2      ! ISUSYN = ISMN
      IFLAG_H(22) = (NMCH-1)/2      ! ISMC
      IFLAG_H(23) = (NMCH-1)/2      ! ISUSYC = ISMC
*-----------------------------------------------------------------------
      CALL FILLPARA(NSMIN,NSSIN,SMPARA_H,SSPARA_H,NFLAG,IFLAG_H)
      MCH=SSPARA_H(2)
*JSL:05/APR2005 IFLAG_H(57) has been added
      IF(IFLAG_H(57).GT.0) THEN
       print*,'ERROR! IFLAG_H(57) = ',IFLAG_H(57)
       IFLAG_H(57)=0
       STOP
      ENDIF
*-----------------------------------------------------------------------
*NOTE: If IFLAG_H(11)=1, the returned MCH from FILLHIGGS is not the pole 
*mass but an effective potential mass of the charged Higgs boson.
*
      CALL FILLHIGGS(NSMIN,NSSIN,SMPARA_H,SSPARA_H,NFLAG,IFLAG_H,MCH
     .              ,HMASS_H,OMIX_H)
      IERR1=IFLAG_H(50)+IFLAG_H(51)+IFLAG_H(52)+IFLAG_H(54)
     .      +IFLAG_H(55)
      IF(IERR1.GT.0) THEN
       IF(IFLAG_H(50).EQ.1) print*,'ERROR! IFLAG_H(50) = ',IFLAG_H(50)
       IF(IFLAG_H(51).EQ.1) print*,'ERROR! IFLAG_H(51) = ',IFLAG_H(51)
       IF(IFLAG_H(52).EQ.1) print*,'ERROR! IFLAG_H(52) = ',IFLAG_H(52)
       IF(IFLAG_H(54).EQ.1) print*,'ERROR! IFLAG_H(54) = ',IFLAG_H(54)
       IF(IFLAG_H(55).EQ.1) print*,'ERROR! IFLAG_H(55) = ',IFLAG_H(55)
       IFLAG_H(50)=0
       IFLAG_H(51)=0
       IFLAG_H(52)=0
       IFLAG_H(54)=0
       IFLAG_H(55)=0
       STOP
      ENDIF
      IF(IFLAG_H(53).EQ.1) THEN
       print*,'WARNING! IFLAG_H(53) = ',IFLAG_H(53)
       IFLAG_H(53)=0
      ENDIF
*-----------------------------------------------------------------------
      CALL FILLCOUPL(NSMIN,NSSIN,SMPARA_H,SSPARA_H,NFLAG,IFLAG_H,MCH
     . ,HMASS_H,OMIX_H,STMASS_H,STMIX_H,SBMASS_H,SBMIX_H,STAUMASS_H
     . ,STAUMIX_H,SNU3MASS_H,MC_H,UL_H,UR_H,MN_H,N_H,NCMAX,NHC_H,SHC_H
     . ,CHC_H)
      IERR2=IFLAG_H(54)+IFLAG_H(56)
      IF(IERR2.GT.0) THEN
       IF(IFLAG_H(54).EQ.1) print*,'ERROR! IFLAG_H(54) = ',IFLAG_H(54)
       IF(IFLAG_H(56).EQ.1) print*,'ERROR! IFLAG_H(56) = ',IFLAG_H(56)
       IFLAG_H(54)=0
       IFLAG_H(56)=0
       STOP
      ENDIF
*-----------------------------------------------------------------------
      CALL FILLGAMBR(NFLAG,IFLAG_H,MCH,HMASS_H,NCMAX,NHC_H,SHC_H
     . ,CHC_H,STMASS_H,STMIX_H,SBMASS_H,SBMIX_H,STAUMASS_H,STAUMIX_H
     . ,SNU3MASS_H,MC_H,MN_H,NMNH,GAMBRN,NMCH,GAMBRC)
*-----------------------------------------------------------------------
*
*============ CompHEP INTERFACE ====================

* Neutralino
      do  I=1,4
        write(*,*) '1 0', I,MN_H(I)
      enddo

      do I=1,4
      do J=1,4
        write(*,*) '1', I,J,DREAL(N_H(I,J))
        write(*,*) '2', I,J,DIMAG(N_H(I,J))
                
      enddo
      enddo

* Chargino 
      do  I=1,2
        write(*,*) '3 0', I,MC_H(I)
      enddo

      do I=1,2
      do J=1,2
        write(*,*) '5', I,J,DREAL(UL_H(I,J))
        write(*,*) '6', I,J,DIMAG(UL_H(I,J))
        write(*,*) '3', I,J,DREAL(UR_H(I,J))
        write(*,*) '4', I,J,DIMAG(UR_H(I,J))
      enddo
      enddo



* Higgs
c       write(21,fmt='(A3,2x,1PE16.8)') 'MHc', SSPARA_H(2)

      do  I=1,3
        write(*,*) '11 0', I,HMASS_H(I)  
      enddo  

      do I=1,3
      do J=1,3 
        write(*,*) '11', I,J,OMIX_H(I,J)
      enddo
      enddo
	  
	  CALL RADNHTB(NFLAG,IFLAG_H,SBMASS_H,STMASS_H,
     & HB_H,HT_H,CKB_H,CKT_H)
	  CALL HPLAMBDA(HB_H,HT_H,STMASS_H,LR_H,LC_H)
	  
	  do I=1,4
	    write(*,*) '12 1',I,LR_H(I)
      enddo
	  
	  do I=1,3
	    write(*,*) '12 2',I,DREAL(LC_H(I))
		write(*,*) '12 3',I,DIMAG(LC_H(I))
	  enddo
	  
c	  write(*,*) 'new lmbd:', LR_H, LC_H

* sTau

      do  I=1,2
        write(*,*) '21 0',I,STAUMASS_H(I)
      enddo

      do I=1,2
      do J=1,2
         write(*,*) '21',I,J,DREAL(STAUMIX_H(J,I))
         write(*,*) '22',I,J,DIMAG(STAUMIX_H(J,I))
      enddo
      enddo

* sBot

      do  I=1,2
        write(*,*) '23 0',I,SBMASS_H(I)
      enddo

      do I=1,2
      do J=1,2
         write(*,*) '23',I,J,DREAL(SBMIX_H(J,I))
         write(*,*) '24',I,J,DIMAG(SBMIX_H(J,I))
      enddo
      enddo

* sTop
	  
      do  I=1,2
        write(*,*) '25 0',I,STMASS_H(I)
      enddo

      do I=1,2
      do J=1,2
         write(*,*) '25',I,J,DREAL(STMIX_H(J,I))
         write(*,*) '26',I,J,DIMAG(STMIX_H(J,I))
      enddo
      enddo
	  stop
      END
